﻿* Encoding: UTF-8.
*Categorical into Contrast
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_CATCONT*/vers4***************************************************************************************.
define !KO_catcont(factors= !charend('/') /types= !charend('/') /inter= !charend('/') /id= !charend('/') /seq= !charend('/')
                  /spacing= !charend('/') /print= !charend('/') /savelmx= !charend('/'))
!let !ok= 1
!if (!tail(!factors)=!null !and !inter<>!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Factor is single, but INTER is specified.'.
!ifend
!if (!tail(!tail(!tail(!tail(!factors))))<>!null !and !inter='ALL') !then !let !ok= 0
- echo ''.
- echo '>ERROR. INTER=ALL is allowed under no more than 4 factors.'.
!ifend
!if (!savelmx<>!null) !then
 !if (!tail(!tail(!tail(!tail(!factors))))<>!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. The macro allows to specify SAVELMX under no more than 4 factors.'.
 !else !if (!tail(!tail(!tail(!factors)))<>!null !and (!inter='ALL' !or !inter=4 !or !inter='UP 4')) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Under 4 factors, the macro allows to specify SAVELMX with INTER'.
- echo '>not greater than 3.'.
 !ifend !ifend
!ifend
!if (!tail(!types)=' ALL') !then !let !tps= !null !let !type= !head(!types)
 !do !w !in (!factors) !let !tps= !conc(!tps,' ',!type) !doend
!else !if (!index(!types,'{')=0 !and !index(!types,'"')=0 !and !index(!types,"'")=0) !then !let !tps= !types
 !do !w !in (!factors) !let !w2= !head(!tps) !let !tps= !tail(!tps)
  !if (!w2=!null) !then !let !tps= 0 !break !ifend
 !doend
 !if (!tps<>!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. The length of keyword list TYPES is not equal to the number of'.
- echo '>factors FACTORS.'.
 !else !let !tps= !types
 !ifend
!else !let !tps= !types
!ifend !ifend
!if (!ok) !then
-set mxloops 1E9 errors none.
-temp.
-count #miss= !id !factors (missing).
-select if #miss=0.
-set errors list.
-weight off.
-matrix.
-comp ok= 1.
-print /title '**** CATEGORICAL INTO CONTRAST ****'.
 !let !f= !null !let !sfac= !null !let !nff= 0 !let !tps= !conc(!tps,'{')
 !let !alpha= 'a b c d e f g h i j k l m n o p q r s t u v w x y z'
-comp index= {'1','2','3','4','5','6','7','8','9','0','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'}.
 !do !w !in (!factors)
  !let !nota= !head(!alpha) !let !alpha= !tail(!alpha) !let !f= !conc(!f,' ') !let !sfac= !conc(!sfac,' ',!nota)
- get fac /var= !w.
  !if (!nota='a') !then
-  print nrow(fac) /title 'Number of valid cases (listwise):'.
  !ifend
  !if (!print<>'NONE') !then
-  print /title '----------'.
  !ifend
- print !quote(!nota) /title !quote(!conc('Symbol of factor ',!upcase(!w),':')) /format= a8.
- do if cmin(fac)=cmax(fac).
-  print 1 /title 'Number of levels (k) after listwise deletion of nonvalid cases:' /space= 0.
-  print /title '>ERROR. Factor is a constant.'.
-  comp ok= 0.
- else.
-  comp des= design(fac).
-  comp k= ncol(des).
   !if (!print<>'NONE') !then
-   print k /title 'Number of levels (k) after listwise deletion of nonvalid cases:' /space= 0.
   !ifend
-  do if k>36.
-   print /title '>ERROR. Number of levels in the factor exceeds 36.'.
-   comp ok= 0.
-  end if.
-  comp freq= csum(des).
-  comp list= t(csum(fac*make(1,k,1)&*des)/freq).
-  comp grd= grade(list).
-  comp list(grd)= list.
-  comp freq(grd)= freq.
-  comp freq= t(freq).
-  comp des(:,grd)= des.
-  comp ind= index(1:nrow(list)).
   !if (!print<>'NONE') !then
-   print {list,freq} /title 'Levels: their indices, codes, and counts:' /rnam= ind /space= 0.
   !ifend
- end if.
  !let !type= !head(!tps)
  !if (!type='{' !and !tps='{') !then
-  print /title '>ERROR. Number of elements of list TYPES is less than the number of factors.' /space= 2.
-  comp ok= 0.
   !break
  !ifend
  !if (!type='{') !then !let !ind= !index(!tps,'}') !let !type= !substr(!tps,1,!ind)
-  comp l= !type.
   !let !type= 'User-defined' !let !source= ' (inline)' !let !tps= !substr(!substr(!tps,!ind),2)
  !else !if (!substr(!type,1,1)='"' !or !substr(!type,1,1)="'") !then
-  get l /file= !type.
   !let !type= 'User-defined' !let !source= ' (file)' !let !tps= !tail(!tps)
  !ifend !ifend
  !if (!type= 'User-defined') !then
-  do if ncol(l)<>k or nrow(l)<>k-1.
-   print /title '>ERROR. The size of the read User-defined matrix of contrast coefficients'.
-   print /title '>does not conform to the number of levels. Size must be k-1 x k.' /space= 0.
-   comp ok= 0.
-  end if.
  !else !let !source= !null !let !tps= !tail(!tps)
  !ifend
  !if (!type<>'POL' !and !type<>'WPOL') !then
   !if (!type='IND') !then
-   comp c= ident(k,k-1).
-   comp l= {ident(k-1),make(k-1,1,-1)}.
   !else
    !if (!type='SIM') !then
-    comp l= {ident(k-1),make(k-1,1,-1)}.
    !else !if (!type='DEV') !then
-    comp l= make(k-1,k,-1/k).
-    call setdiag(l,1-1/k).
    !else !if (!type='HEL' !or !type='DIF') !then
-    comp l= t(-1/((k-1):1))*make(1,k,1).
-    call setdiag(l,1).
-    loop i= k-1 to 2 by -1.
-     loop j= 1 to i-1.
-      comp l(i,j)= 0.
-     end loop.
-    end loop.
     !if (!type='DIF') !then
-     comp l= l((k-1):1,k:1).
     !ifend
    !else !if (!type='REP') !then
-    comp l= {ident(k-1),make(k-1,1,0)}+{make(k-1,1,0),-ident(k-1)}.
    !ifend !ifend !ifend !ifend
-   comp c= inv({make(1,k,1/k);l})(:,2:k).
-   comp c= rnd(c*1E14)/1E14.
   !ifend
  !else
-  comp w= !if (!type='POL') !then 1 !else freq !ifend.
   !if (!spacing='ASIS') !then
-   do if any(not list).
-    print /title '>ERROR. With SPACING=ASIS, nonpositive values in the input'.
-    print /title '>factors are not allowed.' /space= 0.
-    comp ok= 0.
-   else.
-    comp i= list.
-   end if.
   !else
-   comp i= t(1:k).
   !ifend
-  comp c= make(k,k+1,0).
-  comp c(:,2)= make(k,1,1).
-  comp cq= 0.
-  loop q= 3 to k+1.
-   comp wc= w&*c(:,q-1).
-   comp wc2= wc&*c(:,q-1).
-   comp aq= csum(i&*wc2)/csum(wc2).
-   do if q>3.
-    comp wc2= c(:,q-2).
-    comp cq= csum(i&*wc&*wc2)/csum(w&*wc2&*wc2).
-   end if.
-   comp c(:,q)= (i-aq)&*c(:,q-1)-cq*c(:,q-2).
-  end loop.
-  comp c= c(:,3:ncol(c)).
-  comp c= c/sqrt(cssq(c))(make(1,k,1),:).
-  comp c= rnd(c*1E14)/1E14.
-  comp l= inv({make(k,1,1),c})(2:k,:).
  !ifend
- do if ok.
   !if (!print='LONG' !or !print=!null) !then
    !if (!type='DIF') !then
     !let !printref= "print /title '(the first level is reference)' /space= 0"
    !else !if (!type<>'POL' !and !type<>'WPOL' !and !type<>'User-defined') !then
     !let !printref= "print /title '(the last level is reference)' /space= 0"
    !ifend !ifend
-   print /title !quote(!conc("Contrast coefficients L' (L matrix transposed) of type ",!type,!source,",")).
-   print t(l) /title 'levels x variables (contrasts):' /rnam= ind /format= f7.4 /space= 0.
-   !printref.
-   print t(rsum(l)) /title 'Sum of contrast coefficients in each contrast:' /format= f7.4.
-   print sscp(t(l)) /title "LL' (diagonal if contrasts of L matrix are orthogonal):" /format= f7.4.
-   print /title 'Coding (C matrix),'.
-   print c /title 'levels x variables (contrasts):' /rnam= ind /format= f7.4 /space= 0.
-   !printref.
-   comp @sum= csum(c).
-   print @sum /title 'Sum of codes in each contrast variable in C matrix:' /format= f7.4.
-   do if k>2.
-    comp @y= sscp(c).
-    comp @coef= @y-t(@sum)*@sum/nrow(c).
-    comp @x= diag(@coef).
-    comp @coef= @coef/sqrt(@x*t(@x)).
-    print @coef /title 'Correlations of contrast variables under balancedness:' /format= f7.4.
-    do if any(abs(@sum)>1E-11).
-     comp @x= diag(@y).
-     comp @coef= @y/sqrt(@x*t(@x)).
-     print @coef /title 'Cosine similarities of contrast variables under balancedness:' /format= f7.4.
-    end if.
-    release @x,@y,@coef.
-   end if.
-   release @sum.
   !ifend
   !if (!savelmx<>!null) !then
    !if (!nff) !then
-    comp lmx= block(lmx,l).
-    comp nlev= {nlev,k}.
    !else
-    comp lmx= l.
-    comp nlev= k.
    !ifend
   !ifend
-  comp sfac= {!if (!nff) !then sfac, !ifend des*t(ind)}.
-  comp vars= {!if (!nff) !then vars, !ifend des*c}.
-  comp explast= {!if (!nff) !then explast, !ifend make(1,k-1,ncol(vars))}.
-  comp names= {!if (!nff) !then names, !ifend {make(1,ncol(c),!quote(!nota));index(1:ncol(c))}}.
   !let !nff= 1
- end if.
 !doend
 !if (!tps<>'{') !then
- print /title '>ERROR. Number of elements of list TYPES is greater than the number of factors.' /space= 2.
- comp ok= 0.
 !ifend
 !let !f= !len(!f)
-do if !f>26.
- print /title '>ERROR. The number of FACTORS is greater than 26.'.
- comp ok= 0.
-end if.
-release fac,des,list.
 !if (!inter<>!null) !then
  !if (!inter='ALL') !then !let !nc= !f
  !else !if (!head(!inter)='UP') !then !let !nc= !tail(!inter)
  !else !let !nc= !inter
  !ifend !ifend
- do if !nc>!f.
-  print /title '>ERROR. The order of interactions requested in INTER >number of factors.'.
-  comp ok= 0.
- end if.
 !ifend
-do if ok.
  !if (!savelmx<>!null) !then 
-  save {{nlev,make(1,ncol(lmx)-!f,0)};lmx} /out= !savelmx.
-  release lmx.
  !ifend
  !if (!id<>!null) !then
-  get id /var= !id.
  !ifend
- comp names= t(names).
  !if (!inter<>!null) !then
-  print /title '----------'.
-  print /title !quote(!conc('Requested is to produce interaction variables (INTER= ',!inter,').')).
-  comp n= ncol(vars).
-  comp vars= t(vars).
-  comp v= t(1:nrow(vars)).
-  comp next= explast+1.
-  comp vec= v.
   !do !k= 2 !to !nc
-   comp nextnew= 0.
-   comp vecnew= make(1,ncol(vec)+1,0).
-   loop i= 1 to nrow(vec).
-    do if next(i)<=nrow(v).
-     comp ind#= next(i):nrow(v).
-     comp vecnew= {vecnew;{vec(i,:)(make(1,ncol(ind#),1),:),v(ind#)}}.
-     comp nextnew= {nextnew,explast(ind#)+1}.
-    end if.
-   end loop.
-   comp next= nextnew(2:ncol(nextnew)).
-   comp vec= vecnew(2:nrow(vecnew),:).
-   comp !conc('@comb#',!k)= vec.
   !doend
-  release v,next,vec,explast,nextnew,vecnew,ind#.
   !if (!inter='ALL' !or !head(!inter)='UP') !then !let !ret= 'ALL' !ifend
-  comp nam= names.
   !do !k= 2 !to !nc !let !kk= !conc('@comb#',!k)
    !if (!ret='ALL' !or !inter=!k) !then
-    comp intk= vars(!kk(:,1),:).
-    loop i= 2 to !k.
-     comp intk= intk&*vars(!kk(:,i),:).
-    end loop.
-    comp vars= {vars;intk}.
-    comp ncomb= nrow(!kk).
-    comp namk= reshape(nam(reshape(!kk,1,ncomb*!k),:),ncomb,2*!k).
-    comp names= {names,make(nrow(names),ncol(namk)-ncol(names),' ');namk}.
    !ifend
-   release !kk.
   !doend
-  release intk.
-  comp vars= t(vars).
-  do if any(cmin(vars)=cmax(vars)).
-   print /title '----------'.
-   print /title '>WARNING. Some created interaction variables are constants.'.
-  end if.
  !ifend
  !if (!seq='EFFECT' !and !inter<>!null) !then
-  comp names_n= names(1:n,:).
-  comp names= names((n+1):nrow(names),:).
-  comp indcut= (1:ncol(names):2).
-  comp cut= names(:,indcut).
-  comp @notind= make(1,ncol(names)-ncol(indcut),0).
-  comp @c= 0.
-  loop @i= 1 to ncol(names).
-   do if not any(indcut=@i).
-    comp @c= @c+1.
-    comp @notind(@c)= @i.
-   end if.
-  end loop.
-  comp remn= names(:,@notind).
-  comp nempt= rsum(cut<>' ').
-  comp cut= {nempt,cut}.
-  comp rn= t(1:nrow(cut)).
-  comp cut= {cut,rn}.
-  comp cut(grade(cut(:,1)),:)= cut.
-  loop @i= 2 to ncol(cut)-1.
-   comp @lst= 0.
-   loop.
-    comp @fst= @lst+1.
-    loop @lst= @fst to nrow(cut)-1.
-    end loop if any(cut(@lst+1,1:(@i-1))<>cut(@lst,1:(@i-1))).
-    comp cut(grade(cut(@fst:@lst,@i))+@fst-1,:)= cut(@fst:@lst,:).
-   end loop if @lst=nrow(cut).
-  end loop.
-  comp rn(cut(:,ncol(cut)))= rn.
-  comp cut= cut(:,1:(ncol(cut)-1)).
-  comp cut= cut(:,2:ncol(cut)).
-  comp remn(rn,:)= remn.
-  comp names= make(nrow(remn),ncol(remn)+ncol(cut),0).
-  comp names(:,indcut)= cut.
-  comp @r= 0.
-  loop @i= 1 to ncol(names).
-   do if not any(indcut=@i).
-    comp @r= @r+1.
-    comp names(:,@i)= remn(:,@r).
-   end if.
-  end loop.
-  comp names= {names_n;names}.
-  comp vars(:,rn+n)= vars(:,(n+1):ncol(vars)).
-  release names_n,cut,remn,rn.
  !ifend
- comp vars= rnd(vars*1E14)/1E14.
  !if (!print<>'NONE') !then
-  print /title '----------'.
-  print /title 'Determinants of the set of all output contrast variables'.
-  comp scp= sscp(vars).
-  print det(scp/nrow(vars)) /title 'of MSCP matrix:' /format= f15.12.
-  comp x= csum(vars)(make(1,ncol(vars),1),:).
-  comp x= x&*t(x).
-  comp scp= scp*nrow(vars)-x.
-  comp x= diag(scp)*make(1,ncol(vars),1).
-  comp x= sqrt(x&*t(x)).
-  print det(scp/(x+(x=0))) /title 'of correlation matrix:' /format= f15.12 /space= 0.
  !ifend
- write names /out= 'temp_KO_catcont_1.sps' /field= 1 to 8 /format= a1.
- write nrow(names) /out= 'temp_KO_catcont_2.sps' /field= 1 to 8 /format= f8.
- save {sfac,!if (!id<>!null) !then id, !ifend vars} /out= * /vari= !sfac /string= !sfac.
  !if (!savelmx<>!null !and !inter<>!null) !then
-  comp names= names(:,1:ncol(names):2).
-  save names /out= 'temp_KO_catcont.sav' /vars= col1 to col3.
  !ifend
-else.
- save 0 /out= *.
- print /title '>!KO_CATCONT is executed incorrectly.' /space= 0.
-end if.
-end matrix.
-set results none errors none.
-matrix.
-get vars /names= names.
-do if ncol(vars)>1.
- read nvars /file= 'temp_KO_catcont_2.sps' /size= 1 /field= 1 to 8 /format= f8.
- read nam /file= 'temp_KO_catcont_1.sps' /size={nvars,1} /field= 1 to 8 /format= a8.
- comp names((!f+1):ncol(names))= {!if (!id<>!null) !then !quote(!id), !ifend t(nam)}.
- save vars /out= * /names= names /string= !sfac.
  !if (!savelmx<>!null !and !inter<>!null) !then !let !fno= !null !let !toz= !null
   !if (!f=2) !then !let !bylst= '"a b"'
   !else !if (!f=3) !then
    !if (!inter=2 !or !inter='UP 2') !then !let !bylst= '"a b" "a c" "b c"' !let !toz= 'c b a'
    !else !if (!inter=3) !then !let !bylst= '"a b c"'
    !else !let !bylst= '"a b" "a c" "b c" "a b c"' !let !toz= 'c b a'
    !ifend !ifend
   !else !if (!f=4) !then
    !if (!inter=2 !or !inter='UP 2') !then !let !bylst= '"a b" "a c" "a d" "b c" "b d" "c d"' !let !toz= '"c d" "b d" "b c" "a d" "a c" "a b"'
    !else !if (!inter=3) !then !let !bylst= '"a b c" "a b d" "a c d" "b c d"' !let !toz= 'd c b a'
    !else !let !bylst= '"a b" "a c" "a d" "b c" "b d" "c d" "a b c" "a b d" "a c d" "b c d"' !let !toz= '"c d" "b d" "b c" "a d" "a c" "a b" d c b a'
    !ifend !ifend
   !ifend !ifend !ifend
   !do !w !in (!bylst) !let !fno= !conc(!fno,' ') !let !indx= !len(!fno)
    !if (!indx=10) !then !let !indx= 0 !ifend
-   write {'aggreg',' /out=','"temp_','KO_cat',!quote(!conc('cont_',!indx)),'.sav"'} /out= 'temp_KO_catcont_3.sps' /field= 1 to 36 /format= a6.
-   write {'/break=',!w} /field= 2 to 16 /format= a7.
-   loop i= 1 to nvars.
-    write {'/',nam(i),'=first(',nam(i),')'} /field= 2 to 41 /format= a8.
-   end loop.
   !doend !let !fno= !len(!fno)
  !ifend
-end if.
-end matrix.
-var lev all (sca) !sfac !id (nom).
-erase file 'temp_KO_catcont_1.sps'.
-erase file 'temp_KO_catcont_2.sps'.
-set results list errors list.
 !if (!savelmx<>!null) !then
  !if (!inter<>!null) !then
-  insert file= 'temp_KO_catcont_3.sps' syntax= batch.
  !ifend
- matrix.
- print /title 'Building of L matrix of all the effects.'.
- print /title 'Rows in it are contrasts; they correspond to the created contrast variables'.
- print /title 'and follow the order of those variables in the dataset.' /space= 0.
- print /title 'Columns correspond to the factor levels and their combinations making the' /space= 0.
- print /title 'design, including reference levels. The effects of the model form blocks' /space= 0.
- print /title 'of adjacent columns:' /space= 0.
- get lmx /file= !savelmx.
- comp fstcol= 1.
  !let !flst= 'a b c d'
  !do !i= 1 !to !f !let !w= !head(!flst) !let !flst= !tail(!flst)
-  print fstcol /title !quote(!conc('Number of the 1st column of effect ',!w,':')) /space= 0.
-  comp fstcol= fstcol+lmx(1,!i).
  !doend
- comp lmx= lmx(2:nrow(lmx),:).
- comp ok= 1.
  !if (!inter<>!null) !then
-  get names /file= 'temp_KO_catcont.sav'.
-  comp names= t(names).
   !do !i= 1 !to !fno !let !indx= !i
    !if (!indx=10) !then !let !indx= 0 !ifend
    !let !w= !head(!bylst) !let !bylst= !tail(!bylst) !let !z= !head(!toz) !let !toz= !tail(!toz)
-   do if ok.
-    get agg /file= !quote(!conc('temp_KO_catcont_',!indx,'.sav')).
-    comp agg= agg(:,(ncol(agg)-ncol(names)+1):ncol(agg)).
     !if (!len(!z)>0) !then !let !ins= '(ind,:)'
      !if (!len(!z)=1) !then
-      comp @vec= (not csum(names=!quote(!z))).
      !else !let !z= !unquote(!z)
-      comp @vec= (not csum(names=!quote(!subs(!z,1,1)) or names=!quote(!subs(!z,3,1)))).
      !ifend
-     comp @nnz= msum(@vec).
-     comp ind= make(1,@nnz,0).
-     comp @c= 0.
-     loop @i= 1 to ncol(@vec).
-      do if @vec(@i).
-       comp @c= @c+1.
-       comp ind(@c)= @i.
-      end if.
-     end loop.
-     comp l= make(ncol(agg),nrow(agg),0).
-     comp agg= agg(:,ind).
     !else !let !ins= !null
     !ifend
-    do if nrow(agg)-ncol(agg)=1.
-     comp agg= inv({make(nrow(agg),1,1),agg}).
-     comp l!ins= agg(2:nrow(agg),:).
      !if (!i=1) !then
-      comp lmx= {{lmx;make(nrow(l)-nrow(lmx),ncol(lmx),0)},l}.
      !else
-      comp lmx= {lmx,l}.
      !ifend
      !let !eff= !null
      !do !u !in (!unquote(!w)) !let !eff= !conc(!eff,'*',!u) !doend !let !eff= !subs(!eff,2)
-     print fstcol /title !quote(!conc('Number of the 1st column of effect ',!eff,':')) /space= 0.
-     comp fstcol= fstcol+ncol(agg).
-    else.
-     comp ok= 0.
-    end if.
-   end if.
   !doend
  !ifend
- do if ok.
-  print ncol(lmx) /title 'Total number of columns in the matrix:' /space= 0.
-  print /title 'L matrix is saved as file:'.
-  print /title !savelmx /space= 0.
-  save lmx /out= !savelmx.
- else.
-  print /title ">WARNING. Building of L matrix is stopped and it won't be saved,".
-  print /title '>because you requested interactions on which level' /space= 0.
-  print /title '>the cross-factor design has empty cells.' /space= 0.
- end if.
- end matrix.
  !if (!inter<>!null) !then
-  erase file 'temp_KO_catcont_3.sps'.
-  erase file 'temp_KO_catcont.sav'.
   !do !i= 1 !to !fno !let !indx= !i
    !if (!indx=10) !then !let !indx= 0 !ifend
-   erase file !quote(!conc('temp_KO_catcont_',!indx,'.sav')).
   !doend
  !ifend
 !ifend
!else
-new file.
-echo '>!KO_CATCONT is executed incorrectly.'.
!ifend
!enddefine.
